unit mouse;

interface

var
   Mouse_Installed : boolean;
   MouseX,MouseY : word;
   MouseButton : byte;
   MouseButtons : array[1..3] of boolean;
   Mouse_ThreeButton : boolean;

procedure ShowMouse;
procedure HideMouse;
procedure MouseStatus;
procedure SetMousePosition(mousex, mousey: Word);

implementation

procedure ShowMouse;
{ function 1 - show mouse cursor }
begin
if Mouse_Installed then
 asm
  mov ax,1
  int $33
 end;
end;

procedure HideMouse;
{ function 2 - hide mouse cursor }
begin
if Mouse_Installed then
  asm
     mov ax,2
     int $33
  end;
end;

procedure MouseStatus;
{ function 3 - return mouse position and button status }
begin
if Mouse_Installed then begin
  asm
     mov ax,3
     int $33
     shr cx,1
     mov mousex,cx   {Use SHR AX,1 for 320x200 mode}
     (*inc dx*)
     mov mousey,dx
     mov mousebutton,bl

     {Split Mouse Buttons}
     mov di,OFFSET MouseButtons
     mov bh,bl
     and bh,$01
     mov ds:[di  ],bh
     mov bh,bl
     and bh,$02
     mov ds:[di+1],bh
     mov bh,bl
     and bh,$04
     mov ds:[di+2],bh
  end;
end else begin
  Mousex:=0; Mousey:=0; MouseButton:=0; end;
end;

procedure SetMousePosition(mousex, mousey: Word);
{ function 4 - sets mouse position  }
begin
if Mouse_Installed then
asm
  mov ax,4
  mov cx,mousex
  dec cx
  mov dx,mousey
  dec dx
  int $33
end;
end;

begin
  asm
     sub ax,ax
     int $33
     sub cl,cl
     cmp ax,$FFFF
     jne @nomouse
     inc cl
  @nomouse:
     mov mouse_installed,cl

     sub cl,cl
     cmp bx,$0003
     jne @notwobutton
     inc cl
  @notwobutton:
     mov mouse_threebutton,cl
  end;
end.

