{
> I heard something in this echo about someone having Pascal source to view
> .PCX Files and I would appreciate if they would re-post the source if it's
> not too long or tell me where I can get it.  I am also looking For some
> good COMM routines For Pascal, anyone have any or no where I can get some?

The routine I have will only work With 320x200x256c images.

        For all those Pascal Programmers who just want something simple
        to display a 320x200x256 colour PCX File on the screen here it is.
        This was a direct translation from the C source code of PCXVIEW
        written by Lee Hamel (Patch), Avalanche coder.  I removed the
        Inline assembly code so that you beginners can see what was going
        on behind those routines.

Norman Yen - Infinite Dreams BBS - August 11, 1993
}

Unit TEXLoad;

interface

Uses vga256d,starfade,dos,crt,pallib;

Type
  pcxheader_rec = Record
    manufacturer   : Byte;
    version        : Byte;
    encoding       : Byte;
    bits_per_pixel : Byte;
    xmin, ymin     : Word;
    xmax, ymax     : Word;
    hres, vres     : Word;
    palette        : Array [0..47] of Byte;
    reserved       : Byte;
    colour_planes  : Byte;
    Bytes_per_line : Word;
    palette_Type   : Word;
  end;

Type
    TexType = array[1..64,1..64] of byte;
    TexNameType = string[8];
    TempTexType = array[1..128,1..128] of byte;

Var
  TempTex : ^TempTexType;

  width,
  depth   : Word;
  Bytes   : Word;
  X,Y : word;
  a,b : byte;
  c,c2 : char;
  overrideblack : boolean;
  DirInfo,DirInfo2 : SearchRec;

  Tex     : array[1..200] of ^TexType;
  TexName : array[1..200] of ^TexNameType;

  TexClass : array[1..50] of array[1..20] of byte;  {50 class types with 20 tiles in each}
  TexClassName : array[1..50] of string[4];
  TexClassCount : array[1..50] of byte;
  TexClassMax : word;

  TempStr : string[4];

  TexSeg  : word;

  Tileable : boolean;
  TileSet : array[1..6] of byte;
    {
      1 - A - First Solid Shape  [Example: Grass in GRST]
      2 - B - Second Solid Shape [Example: Stone in GRST]
      3 - C - Horizontal shift   [Example: Grass left to stone right]
      4 - D - Vertical Shift     [Example: Grass lower to stone upper]
      5 - E - Diagonal           [Example: Small amount of grass lower-left to stone upper-right]
      6 - F - Diagonal           [Example: Large amount of grass lower-left to stone upper-right]
    }


procedure LoadTEX ( Name : string; Tex : pointer );
procedure UpdateTEXColorsSlow(ColorBuffer : pointer);
procedure LoadAllTex;
procedure InitializeMapTileableMode( Class : byte );

implementation

function FindTileType ( Class : byte; TileType : char ) : byte;
var x : byte;
begin
   FindTileType:=0;
   for x:=1 to TexClassCount[Class] do begin
      if TexName[TexClass[Class,X]]^[5]=TileType then begin
         FindTileType:=x;
         end;
   end;
end;

procedure InitializeMapTileableMode( Class : byte );
var x : byte;
    temp : byte;
begin
    TileAble:=true;
    for x:=1 to 6 do begin
       temp:=FindTileType(Class,char(64+x));
       {writeln(temp);}
       if temp=0 then TileAble:=false;
       TileSet[x]:=TexClass[Class,temp];
       end;
       {k:=readkey;}
end;

function Find {File}  ( s : string ) : boolean;
var fi:searchrec;
begin
   findfirst(s,0,fi);
   find:=doserror=0;
end;

procedure UpdateTEXColorsSlow(ColorBuffer : pointer); assembler;
asm
  cli
  push ds

  lds  si, ColorBuffer
  les  di, ColorBuffer
  mov  cx, 3*256

  mov  dx, 03C8h
  xor  al, al
  out  dx, al
  inc  dx
@ColorLoop:
  lodsb
  shr  al,1
  shr  al,1
  stosb
  loop @ColorLoop

  pop  ds
  sti
end;

procedure SaveTEX ( Name : string );
var
  fi      : file;
begin
  assign(fi,name);
  rewrite(fi,1);

{  for b:=1 to 64 do for a:=1 to 64 do
  blockwrite(fi,Tex[X]^[a,b],1);}
  blockwrite(fi,Tex[X]^,sizeof(Tex[X]^));

  close(fi);
end;

procedure LoadTEXQuik ( Name : string );
var
  fi      : file;
begin
  assign(fi,name);
  reset(fi,1);

{  for b:=1 to 64 do for a:=1 to 64 do
  blockread(fi,Tex[X]^[a,b],1);}
  blockread(fi,Tex[X]^,sizeof(Tex[X]^));

  close(fi);
end;

procedure LoadTEX ( Name : string; Tex : pointer );
var
  header  : pcxheader_rec;
  textbuf : array[1..1024] of char;
  fi      : file;
  PCXfile : text;


Procedure Unpack_PCX;
Label
  enddraw, whileloop, readonebyte;
Var
  c,c2 : char;
  temp,bytes,i : word;
begin
  TEXSeg:=Seg(Tex^);
  {temp:=header.bytes_per_line;}
  temp:=128;
  asm
     sub di,di  (*CX Stores Video Offset*)
  end;

for i:=1 to depth do begin
{for i:=1 to 128 do begin}

 bytes:=temp;
whileloop:
  asm
     push di
  end;

    read (PCXfile,c);
  asm
    pop di
    mov al,c
    and al,192
    cmp al,192
    jne readonebyte
    push di
  end;

    { if it's a run of Bytes field }

      { get the run Byte }
      read(PCXfile,c2);

      asm
         pop di
         sub cx,cx
         mov cl,c
         and cl,63

         sub bytes,cx                 (* Dec(r,run) *)

         mov es,TEXSeg

         mov al,c2

         db $066
         rep stosb

         cmp bytes,0
         jne whileloop
         jmp enddraw

      readonebyte:

         mov es,TexSeg
         mov al,c

         mov es:[di],al
         inc di

         dec bytes
         jnz whileloop
      end;

enddraw:
{  asm
     add di,320
     sub di,temp
  end;}

 end;
end;


begin

    assign(fi, Name);
    reset(fi, 1);
    blockread (fi, header, sizeof(header));
    if (header.manufacturer = 10) and (header.version = 5) and
       (header.bits_per_pixel = 8) and (header.colour_planes = 1) then
    begin
      seek(fi, Filesize(fi) - 768);

      blockread(fi, colors, 768);

      close(fi);

      assign(PCXfile,name);
      settextbuf(PCXfile,textbuf);
      reset(PCXfile);

      for byte(c):=1 to 128 do read(PCXfile,c2);

      width := succ(header.xmax) - header.xmin;
      depth := succ(header.ymax) - header.ymin;
      Bytes := header.Bytes_per_line;
      Unpack_PCX;
      close(pcxfile);

    end;
end;

procedure RemapColor;
var
   aa,bb : byte;
   z   : word;
   tempcol,col : byte;
   r,g,b : byte;
   temp : word;
   loop : byte;
   colorchange : array[0..255] of byte;
begin
(*   for col:=0 to 255 do begin
   r:=round(Colors[col].r*0.3);
   g:=round(Colors[col].g*0.3);
   b:=round(Colors[col].b*0.3);

   z:=65000; tempcol:=0;
   for loop:=0 to 255 do begin         { Only first 240 colors for textures }
       temp:=(abs(Colors2[loop].r-r))+(abs(Colors2[loop].g-g))+(abs(Colors2[loop].b-b));

       if z>temp then begin
       z:=temp;
       tempcol:=loop;
       end;
   end;
   colorchange[col]:=tempcol;

{   writeln(r*2+g*3+b,' ',
           round((r+g*2+b)/4),'  ');}
{   k:=readkey;}

   {colorchange[col]:=round( (r*2+g*3+b)/6 );}
   {colorchange[col]:=round( (r+g+b)/3 );}
   end;

   for a:=1 to 128 do for b:=1 to 128 do
   Tex[x]^[a,b]:=Colorchange[Tex[x]^[a,b]];*)

   for aa:=1 to 64 do for bb:=1 to 64 do begin

   r:=round (
   ( colors[TempTex^[aa shl 1  ,bb shl 1  ]].r +
     colors[TempTex^[aa shl 1-1,bb shl 1  ]].r +
     colors[TempTex^[aa shl 1  ,bb shl 1-1]].r +
     colors[TempTex^[aa shl 1-1,bb shl 1-1]].r )
     /4*0.3);
   g:=round (
   ( colors[TempTex^[aa shl 1  ,bb shl 1  ]].g +
     colors[TempTex^[aa shl 1-1,bb shl 1  ]].g +
     colors[TempTex^[aa shl 1  ,bb shl 1-1]].g +
     colors[TempTex^[aa shl 1-1,bb shl 1-1]].g )
     /4*0.3);
   b:=round (
   ( colors[TempTex^[aa shl 1  ,bb shl 1  ]].b +
     colors[TempTex^[aa shl 1-1,bb shl 1  ]].b +
     colors[TempTex^[aa shl 1  ,bb shl 1-1]].b +
     colors[TempTex^[aa shl 1-1,bb shl 1-1]].b )
     /4*0.3);

   z:=65000; tempcol:=0;
   for loop:=0 to 255 do begin         { Only first 240 colors for textures }
       temp:=(abs(Colors2[loop].r-r))+(abs(Colors2[loop].g-g))+(abs(Colors2[loop].b-b));

       if z>temp then begin
       z:=temp;
       tempcol:=loop;
       end;
   end;
   Tex[x]^[aa,bb]:=tempcol;
   {colorchange[col]:=tempcol;}

{   writeln(r*2+g*3+b,' ',
           round((r+g*2+b)/4),'  ');}
{   k:=readkey;}

   {colorchange[col]:=round( (r*2+g*3+b)/6 );}
   {colorchange[col]:=round( (r+g+b)/3 );}
   end;

end;

procedure LoadAllTex;
begin
   overrideblack:=false;

   new(TempTex);

   {Load in ALL PCX file}
   FindFirst('*.PCX',$3F,DirInfo);
   X := 0;
   TexClassMax:=0;

   while DosError = 0 do begin
   inc(X);
   new(Tex[X]);
   new(TexName[X]);

   {TexSeg:=Seg(Tex[X]^);
   Mem[TexSeg:0000]:=0;}

   TexName[X]^:=DirInfo.Name;

   FindFirst(copy(DirInfo.Name,1,8)+'.TEX',$3F,DirInfo2);
if (DosError=0) and (DirInfo.Time<=DirInfo2.Time) then begin
   LoadTexQuik(copy(DirInfo.Name,1,8)+'.TEX');
end else begin
   writeln('Importing Texture: ',DirInfo.Name);
   LoadTex(DirInfo.Name,TempTex);

   RemapColor;
   SaveTEX(copy(DirInfo.Name,1,8)+'.TEX');
end;

   {Find Existing Class Type}
   a:=0;
   TempStr:=copy(DirInfo.Name,1,4);
   {writeln(TempStr);}
   for y:=1 to TexClassMax do
      if TempStr=TexClassName[Y] then a:=1;

   if a=1 then begin             { Add to Existing Class }
      inc(TexClassCount[Y]);
      TexClass[Y][TexClassCount[Y]]:=X;
   end else begin
      inc(TexClassMax);
      Y:=TexClassMax;
      TexClass[Y][1]:=X;
      TexClassCount[Y]:=1;
      TexClassName[Y]:=TempStr;
   end;

   FindNext(DirInfo);
   end;
   initializemaptileablemode(2);
end;


begin
end.
